summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorSebastien Braun2010-10-13 03:34:39 +0200
committerSebastien Braun2010-10-13 03:34:39 +0200
commit45ffedadfb42973e244debdb63300e9aefda5414 (patch)
treecff17d88f99e17806565cdf334dade600380bb5c
parentFix key case comparison bug (diff)
downloadpvs-45ffedadfb42973e244debdb63300e9aefda5414.tar.gz
pvs-45ffedadfb42973e244debdb63300e9aefda5414.tar.xz
pvs-45ffedadfb42973e244debdb63300e9aefda5414.zip
Introduce init-scripts for pvsprivinputd
-rw-r--r--src/input/CMakeLists.txt9
-rw-r--r--src/input/pvsprivinputd.gentooinit.in37
-rw-r--r--src/input/pvsprivinputd.lsbinit.in152
3 files changed, 198 insertions, 0 deletions
diff --git a/src/input/CMakeLists.txt b/src/input/CMakeLists.txt
index 4f9eb4d..26eeb64 100644
--- a/src/input/CMakeLists.txt
+++ b/src/input/CMakeLists.txt
@@ -164,3 +164,12 @@ add_library(
${pvsinput_SRCS}
${pvsinput_RCS}
)
+
+if(EXISTS /etc/gentoo-release)
+ configure_file(${CMAKE_CURRENT_SOURCE_DIR}/pvsprivinputd.gentooinit.in ${CMAKE_CURRENT_BINARY_DIR}/pvsprivinputd.init @ONLY@)
+else()
+ configure_file(${CMAKE_CURRENT_SOURCE_DIR}/pvsprivinputd.lsbinit.in ${CMAKE_CURRENT_BINARY_DIR}/pvsprivinputd.init @ONLY@)
+endif()
+install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/pvsprivinputd.init
+ DESTINATION /etc/init.d
+ RENAME pvsprivinputd)
diff --git a/src/input/pvsprivinputd.gentooinit.in b/src/input/pvsprivinputd.gentooinit.in
new file mode 100644
index 0000000..03ade0f
--- /dev/null
+++ b/src/input/pvsprivinputd.gentooinit.in
@@ -0,0 +1,37 @@
+#!/sbin/runscript
+# Copyright (C) 2010 OpenSKX Project, Computer Center of the University of Freiburg, Germany
+# This program is free software distributed under the GPL version 2.
+# See http://openslx.org/COPYING
+
+opts="${opts} reload"
+
+PVSPRIVINPUTD_BINARY="@CMAKE_INSTALL_PREFIX@/sbin/pvsprivinputd"
+PVSPRIVINPUTD_PIDFILE="/var/run/pvsprivinputd.pid"
+
+depend() {
+ use net
+ use logger
+ before dbus
+}
+
+start() {
+ ebegin "Starting pvsprivinputd"
+ start-stop-daemon --start --pidfile "${PVSPRIVINPUTD_PIDFILE}" \
+ --exec "${PVSPRIVINPUTD_BINARY}" -- \
+ -d -lsyslog
+ eend $?
+}
+
+stop() {
+ ebegin "Stopping pvsprivinputd"
+ start-stop-daemon --stop --signal SIGINT --pidfile "${PVSPRIVINPUTD_PIDFILE}" \
+ --exec "${PVSPRIVINPUTD_BINARY}"
+ eend $?
+}
+
+reload() {
+ ebegin "Realoding pvsprivinputd's configuration"
+ start-stop-daemon --stop --signal SIGHUP --pidfile "${PVSPRIVINPUTD_PIDFILE}" \
+ --oknodo --exec "${PVSPRIVINPUTD_BINARY}"
+ eend $?
+}
diff --git a/src/input/pvsprivinputd.lsbinit.in b/src/input/pvsprivinputd.lsbinit.in
new file mode 100644
index 0000000..9b4293e
--- /dev/null
+++ b/src/input/pvsprivinputd.lsbinit.in
@@ -0,0 +1,152 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides: pvsprivinputd
+# Required-Start: $remote_fs $syslog
+# Required-Stop: $remote_fs $syslog
+# Default-Start: 2 3 4 5
+# Default-Stop: 0 1 6
+# Short-Description: PVS Privileged Input Daemon
+# Description: Support system service for PVS.
+### END INIT INFO
+
+# Author: Sebastien Braun <sebastien@sebbraun.de>
+#
+# Please remove the "Author" lines above and replace them
+# with your own name if you copy and modify this script.
+
+# Do NOT "set -e"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="Support system service for PVS"
+NAME=pvsprivinputd
+DAEMON=@CMAKE_INSTALL_PREFIX@/sbin/pvsprivinputd
+DAEMON_ARGS="-d -lsyslog"
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/$NAME
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+ # Return
+ # 0 if daemon has been started
+ # 1 if daemon was already running
+ # 2 if daemon could not be started
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
+ || return 1
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
+ $DAEMON_ARGS \
+ || return 2
+ # Add code here, if necessary, that waits for the process to be ready
+ # to handle requests from services started subsequently which depend
+ # on this one. As a last resort, sleep for some time.
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+ # Return
+ # 0 if daemon has been stopped
+ # 1 if daemon was already stopped
+ # 2 if daemon could not be stopped
+ # other if a failure occurred
+ start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
+ RETVAL="$?"
+ [ "$RETVAL" = 2 ] && return 2
+ # Wait for children to finish too if this is a daemon that forks
+ # and if the daemon is only ever run from this initscript.
+ # If the above conditions are not satisfied then add some other code
+ # that waits for the process to drop all resources that could be
+ # needed by services started subsequently. A last resort is to
+ # sleep for some time.
+ start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
+ [ "$?" = 2 ] && return 2
+ # Many daemons don't delete their pidfiles when they exit.
+ rm -f $PIDFILE
+ return "$RETVAL"
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+ #
+ # If the daemon can reload its configuration without
+ # restarting (for example, when it is sent a SIGHUP),
+ # then implement that here.
+ #
+ start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
+ return 0
+}
+
+case "$1" in
+ start)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+ do_start
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ stop)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ status)
+ status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
+ ;;
+ reload|force-reload)
+ #
+ # If do_reload() is not implemented then leave this commented out
+ # and leave 'force-reload' as an alias for 'restart'.
+ #
+ log_daemon_msg "Reloading $DESC" "$NAME"
+ do_reload
+ log_end_msg $?
+ ;;
+ restart)
+ log_daemon_msg "Restarting $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1)
+ do_start
+ case "$?" in
+ 0) log_end_msg 0 ;;
+ 1) log_end_msg 1 ;; # Old process is still running
+ *) log_end_msg 1 ;; # Failed to start
+ esac
+ ;;
+ *)
+ # Failed to stop
+ log_end_msg 1
+ ;;
+ esac
+ ;;
+ *)
+ echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+ exit 3
+ ;;
+esac
+
+: